;Small Sprite Editor
;(c) 1989 MJSoft Sys. Soft.

	phase	32768

buf	equ	23296

	jp	sped
	jp	roed

sped	xor	a
	call	1601h
	ld	a,(23658)
	push	af
	ld	a,8
	ld	(23658),a
	ld	ix,pars
new	call	text
	db	22,0,0
	dm	'Sprite #$'
	call	hexbin
	ld	(spnum),a
disp	call	cls
	call	mriz
	call	revrs
	call	data
	xor	a
	call	1601h
	ld	bc,44800
	ld	(cursp),bc
loop	call	actual
wait	call	curs
	halt
	halt
	call	curs
	halt
	halt
	ld	bc,7ffeh
	in	a,(c)
	and	4
	call	z,move
	ld	bc,0fbfeh
	in	a,(c)
	rrca
	call	nc,up
	ld	bc,0fdfeh
	in	a,(c)
	rrca
	call	nc,down
	ld	bc,0dffeh
	in	a,(c)
	rrca
	push	af
	call	nc,rght
	pop	af
	rrca
	call	nc,left
	ld	a,(23560)
	or	a
	jr	z,loop
	ld	(iy-50),0
	cp	'#'
	jp	z,basic
	cp	'N'
	jr	z,new
	ld	de,1
	cp	'8'
	jr	z,mag
	ld	de,00ffh
	cp	'5'
	jr	z,mag
	ld	de,0ff00h
	cp	'6'
	jr	z,mag
	ld	de,0100h
	cp	'7'
	jr	z,mag
	cp	'G'
	jr	z,grid
	cp	'`'
	jr	z,clear
	cp	'?'
	jr	z,copy
	cp	'T'
	jp	z,turn
	jr	wait

mag	ld	l,(ix+6)
	ld	h,(ix+7)
	ld	a,h
	add	a,d
	cp	5
	jp	nc,loop
	or	a
	jp	z,loop
	ld	h,a
	ld	a,l
	add	a,e
	cp	8
	jp	nc,loop
	or	a
	jp	z,loop
	ld	l,a
	ld	(ix+6),l
	ld	(ix+7),h
	ld	a,l
	sla	a
	sla	a
	ld	(ix+2),a
	sla	a
	ld	(ix),a
	sla	a
	sla	a
	ld	(ix+3),a
	ld	a,h
	sla	a
	sla	a
	sla	a
	ld	(ix+1),a
	sla	a
	sla	a
	ld	(ix+4),a
	ld	b,(ix+6)
	ld	c,(ix+1)
	xor	a
mag1	add	a,c
	djnz	mag1
	ld	(ix+5),a
	jp	disp

basic	pop	af
	ld	(23658),a
	ret

grid	ld	a,(grsw)
	xor	1
	ld	(grsw),a
	jp	disp

clear	call	sprad
	ld	b,(ix+5)
clr1	ld	(hl),0
	inc	hl
	djnz	clr1
	jp	disp

copy	call	text
	db	22,0,0
	dm	'Copy #$'
	call	hexbin
	ld	b,a
	ld	a,(spnum)
	push	af
	ld	a,b
	ld	(spnum),a
	call	sprad
	pop	af
	push	hl
	ld	(spnum),a
	call	sprad
	ld	c,(ix+5)
	ld	b,0
	pop	de
	ex	de,hl
	ldir
	jp	disp

turn	call	sprad
	push	hl
	ld	de,buf
	ld	b,0
	ld	c,(ix+5)
	ldir
	pop	hl
	ld	b,(ix+5)
tu1	ld	(hl),0
	inc	hl
	djnz	tu1
	call	cls
	call	mriz
	ld	bc,44800
	ld	hl,buf
	ld	e,(ix+6)
	ld	d,0
	dec	de
	add	hl,de
	ld	e,1
	ld	d,(ix)
tu2	push	de
	push	bc
	ld	d,(ix+1)
	push	hl
tu3	ld	a,(hl)
	and	e
	jr	z,tu3b
	ld	(cursp),bc
	push	bc
	push	de
	push	hl
	call	curs
	call	mov1
	pop	hl
	pop	de
	pop	bc
tu3b	push	de
	ld	e,(ix+6)
	ld	d,0
	add	hl,de
	pop	de
	ld	a,c
	add	a,4
	ld	c,a
	dec	d
	jr	nz,tu3
	pop	hl
	pop	bc
	pop	de
	ld	a,b
	sub	4
	ld	b,a
	rlc	e
	jr	nc,tu4
	dec	hl
tu4	dec	d
	jr	nz,tu2
	jp	loop

left	ld	a,(cursp)
	or	a
	ret	z
	sub	4
	ld	(cursp),a
	ret

rght	ld	a,(cursp)
	add	a,4
	cp	(ix+3)
	ret	nc
	ld	(cursp),a
	ret

up	ld	a,(cursp+1)
	cp	175
	ret	nc
	add	a,4
	ld	(cursp+1),a
	ret

down	ld	a,(cursp+1)
	ld	b,a
	ld	a,175
	sub	b
	add	a,4
	cp	(ix+4)
	ret	nc
	ld	a,b
	sub	4
	ld	(cursp+1),a
	ret

text	pop	hl
	ld	a,(hl)
	inc	hl
	push	hl
	cp	'$'
	ret	z
	rst	16
	jr	text

hexnin	call	keyin
	ld	c,a
	sub	'0'
	jr	c,hexnin
	cp	10
	jr	c,hni1
	cp	17
	jr	c,hexnin
	sub	7
	cp	16
	jr	nc,hexnin
hni1	ld	b,a
	ld	a,c
	rst	16
	ld	a,b
	ret

hexbin	call	hexnin
	rlca
	rlca
	rlca
	rlca
	ld	h,a
	call	hexnin
	or	h
	ret

keyin	ld	a,(23560)
	or	a
	jr	z,keyin
	ld	(iy-50),0
	ret

mriz	ld	a,(grsw)
	or	a
	ret	z
	ld	bc,44800
	ld	d,(ix+1)
mr2	ld	e,(ix+2)
	call	mrl3
	dec	b
	ld	e,(ix)
	call	mrl2
	dec	b
	ld	e,(ix)
	call	mrl2
	dec	b
	ld	e,(ix)
	call	mrl2
	dec	b
	dec	d
	jr	nz,mr2
	ld	e,(ix+2)
mrl3	push	bc
	call	22aah
mra	ld	(hl),255
	inc	hl
	dec	e
	jr	nz,mra
	ld	(hl),128
	pop	bc
	ret

mrl2	push	bc
	call	22aah
	ld	b,a
	or	a
	ld	c,128
	jr	z,mr4
mr3	rrc	c
	djnz	mr3
mr4	ld	a,c
	or	(hl)
	ld	(hl),a
	rrc	c
	jr	nc,mr5
	inc	hl
mr5	rrc	c
	jr	nc,mr6
	inc	hl
mr6	rrc	c
	jr	nc,mr7
	inc	hl
mr7	rrc	c
	jr	nc,mr8
	inc	hl
mr8	ld	a,c
	or	(hl)
	ld	(hl),a
	dec	e
	jr	nz,mr4
	pop	bc
	ret

curs	ld	bc,(cursp)
	dec	b
	ld	d,3
cu1	push	bc
	call	22aah
	or	a
	ld	a,070h
	jr	z,cu2
	ld	a,7
cu2	xor	(hl)
	ld	(hl),a
	pop	bc
	dec	b
	dec	d
	jr	nz,cu1
	ret

revrs	call	sprad
	ld	bc,44800
	ld	d,(ix+1)
re1	push	bc
	ld	e,(ix+6)
re2	ld	a,(hl)
	ex	af,af'
	ld	a,8
	push	hl
re3	ex	af,af'
	rlca
	jr	nc,re4
	push	af
	push	bc
	push	de
	ld	(cursp),bc
	call	curs
	pop	de
	pop	bc
	pop	af
re4	push	af
	ld	a,c
	add	a,4
	ld	c,a
	pop	af
	ex	af,af'
	dec	a
	jr	nz,re3
	pop	hl
	inc	hl
	dec	e
	jr	nz,re2
	pop	bc
	ld	a,b
	sub	4
	ld	b,a
	dec	d
	jr	nz,re1
	ret

sprad	ld	a,(spnum)
	ld	e,(ix+5)
	ld	d,0
	ld	hl,(spbase)
	or	a
	ret	z
spr1	add	hl,de
	dec	a
	jr	nz,spr1
	ret

cls	ld	hl,4000h
	ld	de,4001h
	ld	bc,17ffh
	ld	(hl),0
	ldir
	ret

move	call	curs
	halt
	halt
	halt
	halt
mov1	ld	bc,(cursp)
	ld	a,175
	sub	b
	srl	a
	srl	a
	ld	b,a
	call	sprad
	ld	e,(ix+6)
	ld	a,b
	or	a
	jr	z,mo1
mo0	add	hl,de
	djnz	mo0
mo1	ld	a,c
	srl	a
	srl	a
	ld	b,a
	srl	a
	srl	a
	srl	a
	or	a
	jr	z,mo3
mo2	inc	hl
	dec	a
	jr	nz,mo2
mo3	ld	a,b
	and	7
	ld	b,a
	ld	a,128
	jr	z,mo5
mo4	rrca
	djnz	mo4
mo5	xor	(hl)
	ld	(hl),a
	ret

data	ld	a,254
	call	1601h
	call	text
	db	22,20,0
	dm	'Sprite at:$'
	call	sprad
	ld	b,h
	ld	c,l
	call	2d2bh
	call	2de3h
	call	text
	db	22,19,0
	dm	'Sprite #$'
	ld	a,(spnum)
hexb	push	af
	rrca
	rrca
	rrca
	rrca
	call	hexn
	pop	af
hexn	and	15
	cp	10
	jr	c,hn1
	add	a,7
hn1	add	a,'0'
	rst	16
	ret

actual	call	sprad
	ld	bc,10368
movspr	ex	de,hl
	ld	a,(ix+1)
mos1	push	af
	push	bc
	call	22aah
	ex	de,hl
	ld	c,(ix+6)
	ld	b,0
	ldir
	ex	de,hl
	pop	bc
	pop	af
	dec	b
	dec	a
	jr	nz,mos1
	ret

spnum	db	0
grsw	db	1
cursp	db	0,175
pars	db	16,24,8
	db	64,96
	db	48
	db	2,3
spbase	dw	50000

roed	xor	a
	call	1601h
	ld	hl,5800h
	ld	bc,44800
	xor	a
	ld	(spnum),a
	ld	ix,pars
	jr	roloop
ronew	push	bc
	push	hl
	call	text
	db	22,0,0
	dm	'Sprite #  '
	db	8,8,'$'
	call	hexbin
	ld	(spnum),a
	pop	hl
	pop	bc
roloop	call	rcurs
	call	keyin
	push	af
	call	rcurs
	pop	af
	cp	'o'
	jr	z,rleft
	cp	'p'
	jr	z,rrght
	cp	'q'
	jr	z,rup
	cp	'a'
	jr	z,rdown
	cp	'#'
	ret	z
	cp	'c'
	jr	z,ronew
	cp	'm'
	jr	nz,roloop
	push	bc
	push	hl
	call	sprad
	call	movspr
	pop	hl
	pop	bc
	jr	roloop
rleft	ld	a,c
	or	a
	jr	z,roloop
	sub	(ix)
	ld	c,a
	ld	e,(ix+6)
	ld	d,0
	and	a
	sbc	hl,de
	jr	roloop
rrght	ld	a,c
	add	a,(ix)
	jr	c,roloop
	ld	c,a
	ld	e,(ix+6)
	ld	d,0
	add	hl,de
	jr	roloop
rup	ld	a,b
	add	a,(ix+1)
	cp	176
	jr	nc,roloop
	ld	b,a
	ld	de,32
	ld	a,(ix+7)
rup1	and	a
	sbc	hl,de
	dec	a
	jr	nz,rup1
	jr	roloop
rdown	ld	a,b
	sub	(ix+1)
	jr	c,roloop
	ld	b,a
	ld	de,32
	ld	a,(ix+7)
rdo1	add	hl,de
	dec	a
	jr	nz,rdo1
	jr	roloop
rcurs	push	hl
	ld	d,(ix+7)
rcu1	push	hl
	ld	e,(ix+6)
rcu2	ld	a,(hl)
	xor	63
	ld	(hl),a
	inc	hl
	dec	e
	jr	nz,rcu2
	pop	hl
	push	de
	ld	de,32
	add	hl,de
	pop	de
	dec	d
	jr	nz,rcu1
	pop	hl
	ret
